telegram-bot-bash/bashbot.sh

587 lines
19 KiB
Bash
Raw Normal View History

#!/bin/bash
2019-04-24 08:07:46 +00:00
# file: bashbot.sh
# do not edit, this file will be overwritten on update
2015-07-10 05:43:08 +00:00
# bashbot, the Telegram bot written in bash.
2019-04-01 10:52:25 +00:00
# Written by Drew (@topkecleon) and Daniil Gentili (@danogentili), KayM (@gnadelwartz).
# Also contributed: JuanPotato, BigNerd95, TiagoDanin, iicc1.
# https://github.com/topkecleon/telegram-bot-bash
# Depends on JSON.sh (http://github.com/dominictarr/JSON.sh) (MIT/Apache),
2015-07-10 05:43:08 +00:00
# This file is public domain in the USA and all free countries.
# Elsewhere, consider it to be WTFPLv2. (wtfpl.net/txt/copying)
#
#### $$VERSION$$ v0.90-dev-3-g80a4778
2019-04-01 10:52:25 +00:00
#
# Exit Codes:
# - 0 sucess (hopefully)
# - 1 can't change to dir
2019-04-12 09:27:20 +00:00
# - 2 can't write to tmp, count or token
# - 3 user / command / file not found
2019-04-01 10:52:25 +00:00
# - 4 unkown command
# - 5 cannot connect to telegram bot
2019-05-22 16:43:20 +00:00
# shellcheck disable=SC2140
2019-03-22 16:47:36 +00:00
# are we runnig in a terminal?
2019-03-31 10:12:55 +00:00
if [ -t 1 ] && [ "$TERM" != "" ]; then
CLEAR='clear'
RED='\e[31m'
GREEN='\e[32m'
ORANGE='\e[35m'
NC='\e[0m'
fi
2019-04-23 11:07:20 +00:00
# get location and name of bashbot.sh
export SCRIPT SCRIPTDIR MODULEDIR RUNDIR RUNUSER
2019-04-23 11:07:20 +00:00
SCRIPT="$0"
SCRIPTDIR="$(dirname "$0")"
2019-05-23 10:26:53 +00:00
if [ "$BASHBOT_HOME" != "" ]; then
SCRIPTDIR="$BASHBOT_HOME"
[ "${BASHBOT_ETC}" = "" ] && BASHBOT_ETC="$BASHBOT_HOME"
[ "${BASHBOT_VAR}" = "" ] && BASHBOT_VAR="$BASHBOT_HOME"
fi
2019-04-26 09:17:42 +00:00
MODULEDIR="${SCRIPTDIR}/modules"
2019-04-23 11:07:20 +00:00
2019-04-26 09:17:42 +00:00
RUNDIR="${SCRIPTDIR}"
[ "${RUNDIR}" = "${SCRIPTDIR}" ] && SCRIPT="./$(basename "${SCRIPT}")"
2019-04-23 11:07:20 +00:00
2019-04-23 16:11:24 +00:00
RUNUSER="${USER}" # USER is overwritten by bashbot array
2019-03-31 10:52:11 +00:00
2019-05-23 10:26:53 +00:00
if [ "$1" != "source" ] && [ "$BASHBOT_HOME" != "" ] && ! cd "${RUNDIR}" ; then
2019-04-23 11:07:20 +00:00
echo -e "${RED}ERROR: Can't change to ${RUNDIR} ...${NC}"
2019-03-31 10:52:11 +00:00
exit 1
fi
2019-03-22 16:47:36 +00:00
if [ ! -w "." ]; then
2019-04-23 11:07:20 +00:00
echo -e "${ORANGE}WARNING: ${RUNDIR} is not writeable!${NC}"
2019-03-22 16:47:36 +00:00
ls -ld .
fi
2019-05-23 10:26:53 +00:00
2019-04-23 11:07:20 +00:00
TOKENFILE="${BASHBOT_ETC:-.}/token"
2019-04-19 15:31:01 +00:00
if [ ! -f "${TOKENFILE}" ]; then
if [ "${CLEAR}" = "" ] && [ "$1" != "init" ]; then
2019-04-12 09:27:20 +00:00
echo "Running headless, run ${SCRIPT} init first!"
exit 2
else
${CLEAR}
echo -e "${RED}TOKEN MISSING.${NC}"
echo -e "${ORANGE}PLEASE WRITE YOUR TOKEN HERE OR PRESS CTRL+C TO ABORT${NC}"
read -r token
printf '%s\n' "${token}" > "${TOKENFILE}"
2019-04-12 09:27:20 +00:00
fi
fi
2019-04-23 11:07:20 +00:00
BOTADMIN="${BASHBOT_ETC:-.}/botadmin"
if [ ! -f "${BOTADMIN}" ]; then
2019-04-12 17:39:21 +00:00
if [ "${CLEAR}" = "" ]; then
2019-04-12 09:27:20 +00:00
echo "Running headless, set botadmin to AUTO MODE!"
printf '%s\n' '?' > "${BOTADMIN}"
2019-04-12 09:27:20 +00:00
else
${CLEAR}
echo -e "${RED}BOTADMIN MISSING.${NC}"
2019-04-12 09:27:20 +00:00
echo -e "${ORANGE}PLEASE WRITE YOUR TELEGRAM ID HERE OR ENTER '?'${NC}"
echo -e "${ORANGE}TO MAKE FIRST USER TYPING '/start' TO BOTADMIN${NC}"
read -r admin
[ "${admin}" = "" ] && admin='?'
printf '%s\n' "${admin}" > "${BOTADMIN}"
2019-04-12 09:27:20 +00:00
fi
fi
2019-04-23 11:07:20 +00:00
BOTACL="${BASHBOT_ETC:-.}/botacl"
2019-04-12 11:14:33 +00:00
if [ ! -f "${BOTACL}" ]; then
echo -e "${ORANGE}Create empty ${BOTACL} file.${NC}"
printf '\n' >"${BOTACL}"
2019-04-12 11:14:33 +00:00
fi
2019-04-23 16:11:24 +00:00
TMPDIR="${BASHBOT_VAR:-.}/data-bot-bash"
if [ ! -d "${TMPDIR}" ]; then
mkdir "${TMPDIR}"
elif [ ! -w "${TMPDIR}" ]; then
echo -e "${RED}ERROR: Can't write to ${TMPDIR}!.${NC}"
ls -ld "${TMPDIR}"
2019-04-01 10:52:25 +00:00
exit 2
fi
2019-04-23 11:07:20 +00:00
COUNTFILE="${BASHBOT_VAR:-.}/count"
2019-04-20 14:26:16 +00:00
if [ ! -f "${COUNTFILE}" ]; then
printf '\n' >"${COUNTFILE}"
2019-04-20 14:26:16 +00:00
elif [ ! -w "${COUNTFILE}" ]; then
echo -e "${RED}ERROR: Can't write to ${COUNTFILE}!.${NC}"
ls -l "${COUNTFILE}"
2019-04-01 10:52:25 +00:00
exit 2
2019-03-22 16:47:36 +00:00
fi
BOTTOKEN="$(< "${TOKENFILE}")"
URL="${BASHBOT_URL:-https://api.telegram.org/bot}${BOTTOKEN}"
2019-04-12 18:49:58 +00:00
ME_URL=$URL'/getMe'
UPD_URL=$URL'/getUpdates?offset='
2019-04-26 11:19:34 +00:00
GETFILE_URL=$URL'/getFile'
2019-04-23 16:11:24 +00:00
unset USER
2019-05-22 16:43:20 +00:00
declare -A UPD BOTSENT USER MESSAGE URLS CONTACT LOCATION CHAT FORWARD REPLYTO VENUE iQUERY
export res UPD BOTSENT USER MESSAGE URLS CONTACT LOCATION CHAT FORWARD REPLYTO VENUE iQUERY CAPTION
2019-04-12 18:49:58 +00:00
2019-05-10 09:33:41 +00:00
COMMANDS="${BASHBOT_ETC:-.}/commands.sh"
if [ "$1" != "source" ]; then
if [ ! -f "${COMMANDS}" ] || [ ! -r "${COMMANDS}" ]; then
echo -e "${RED}ERROR: ${COMMANDS} does not exist or is not readable!.${NC}"
ls -l "${COMMANDS}"
exit 3
fi
# shellcheck source=./commands.sh
source "${COMMANDS}" "source"
fi
2016-06-09 12:11:33 +00:00
# internal functions
# $1 URL, $2 filename in TMPDIR
# outputs final filename
download() {
local empty="no.file" file="${2:-${empty}}"
if [[ "$file" = *"/"* ]] || [[ "$file" = "."* ]]; then file="${empty}"; fi
while [ -f "${TMPDIR:-.}/${file}" ] ; do file="$RAMDOM-${file}"; done
getJson "$1" >"${TMPDIR:-.}/${file}" || return
printf '%s\n' "${TMPDIR:-.}/${file}"
}
# $1 postfix, e.g. chatid
# $2 prefix, back- or startbot-
procname(){
printf '%s\n' "$2${ME}_$1"
}
# $1 sting to search for proramm incl. parameters
# retruns a list of PIDs of all current bot proceeses matching $1
proclist() {
# shellcheck disable=SC2009
ps -fu "${UID}" | grep -F "$1" | grep -v ' grep'| grep -F "${ME}" | sed 's/\s\+/\t/g' | cut -f 2
}
# $1 sting to search for proramm to kill
killallproc() {
local procid; procid="$(proclist "$1")"
if [ "${procid}" != "" ] ; then
# shellcheck disable=SC2046
kill $(proclist "$1")
sleep 1
procid="$(proclist "$1")"
# shellcheck disable=SC2046
[ "${procid}" != "" ] && kill $(proclist -9 "$1")
fi
}
# returns true if command exist
_exists()
{
[ "$(LC_ALL=C type -t "$1")" = "file" ]
}
# returns true if function exist
_is_function()
{
[ "$(LC_ALL=C type -t "$1")" = "function" ]
}
DELETE_URL=$URL'/deleteMessage'
delete_message() {
2019-04-26 11:19:34 +00:00
sendJson "${1}" 'message_id: '"${2}"'' "${DELETE_URL}"
}
get_file() {
[ "$1" = "" ] && return
2019-05-22 07:50:48 +00:00
sendJson "" '"file_id": '"${1}""${GETFILE_URL}"
printf '%s\n' "${URL}"/"$(jsonGetString <<< "${res}" '"result","file_path"')"
}
# curl is preffered, but may not availible on ebedded systems
if [ "${BASHBOT_WGET}" = "" ] && _exists curl ; then
# simple curl or wget call, output to stdout
getJson(){
curl -sL "$1"
}
# usage: sendJson "chat" "JSON" "URL"
sendJson(){
2019-04-26 10:26:34 +00:00
local chat="";
[ "${1}" != "" ] && chat='"chat_id":'"${1}"','
res="$(curl -s -d '{'"${chat} $2"'}' -X POST "${3}" \
-H "Content-Type: application/json" | "${JSONSHFILE}" -s -b -n )"
BOTSENT[OK]="$(JsonGetLine '"ok"' <<< "$res")"
BOTSENT[ID]="$(JsonGetValue '"result","message_id"' <<< "$res")"
}
2019-05-20 15:26:21 +00:00
#$1 Chat, $2 what , $3 file, $4 URL, $5 caption
sendUpload() {
[ "$#" -lt 4 ] && return
if [ "$5" != "" ]; then
res="$(curl -s "$4" -F "chat_id=$1" -F "$2=@$3;${3##*/}" -F "caption=$5" | "${JSONSHFILE}" -s -b -n )"
else
res="$(curl -s "$4" -F "chat_id=$1" -F "$2=@$3;${3##*/}" | "${JSONSHFILE}" -s -b -n )"
fi
BOTSENT[OK]="$(JsonGetLine '"ok"' <<< "$res")"
}
else
# simple curl or wget call outputs result to stdout
getJson(){
wget -qO - "$1"
}
# usage: sendJson "chat" "JSON" "URL"
sendJson(){
local chat="";
[ "${1}" != "" ] && chat='"chat_id":'"${1}"','
res="$(wget -qO - --post-data='{'"${chat} $2"'}' \
--header='Content-Type:application/json' "${3}" | "${JSONSHFILE}" -s -b -n )"
BOTSENT[OK]="$(JsonGetLine '"ok"' <<< "$res")"
BOTSENT[ID]="$(JsonGetValue '"result","message_id"' <<< "$res")"
}
2019-05-20 15:26:21 +00:00
sendUpload() {
sendJson "$1" '"text":"Sorry, wget does not support file upload"' "${MSG_URL}"
BOTSENT[OK]="false"
}
fi
# convert common telegram entities to JSON
# title caption description markup inlinekeyboard
title2Json(){
local title caption desc markup keyboard
[ "$1" != "" ] && title=',"title":"'$1'"'
[ "$2" != "" ] && caption=',"caption":"'$2'"'
[ "$3" != "" ] && desc=',"description":"'$3'"'
[ "$4" != "" ] && markup=',"parse_mode":"'$4'"'
[ "$5" != "" ] && keyboard=',"reply_markup":"'$5'"'
echo "${title}${caption}${desc}${markup}${keyboard}"
}
# get bot name
getBotName() {
sendJson "" "" "$ME_URL"
JsonGetString '"result","username"' <<< "$res"
2016-01-06 16:11:56 +00:00
}
2019-05-14 15:56:23 +00:00
# pure bash implementaion, done by KayM (@gnadelwartz)
# see https://stackoverflow.com/a/55666449/9381171
JsonDecode() {
local out="$1" remain="" U=""
local regexp='(.*)\\u[dD]([0-9a-fA-F]{3})\\u[dD]([0-9a-fA-F]{3})(.*)'
while [[ "${out}" =~ $regexp ]] ; do
2019-05-14 15:56:23 +00:00
U=$(( ( (0xd${BASH_REMATCH[2]} & 0x3ff) <<10 ) | ( 0xd${BASH_REMATCH[3]} & 0x3ff ) + 0x10000 ))
remain="$(printf '\\U%8.8x' "${U}")${BASH_REMATCH[4]}${remain}"
out="${BASH_REMATCH[1]}"
done
echo -e "${out}${remain}"
2019-05-14 15:56:23 +00:00
}
JsonGetString() {
sed -n -e '0,/\['"$1"'\]/ s/\['"$1"'\][ \t]"\(.*\)"$/\1/p'
}
JsonGetLine() {
sed -n -e '0,/\['"$1"'\]/ s/\['"$1"'\][ \t]//p'
}
JsonGetValue() {
sed -n -e '0,/\['"$1"'\]/ s/\['"$1"'\][ \t]\([0-9.,]*\).*/\1/p'
2019-04-23 18:37:15 +00:00
}
################
# processing of updates starts here
process_updates() {
local max num debug="$1"
max="$(sed <<< "${UPDATE}" '/\["result",[0-9]*\]/!d' | tail -1 | sed 's/\["result",//g;s/\].*//g')"
2019-05-22 16:43:20 +00:00
# shellcheck source=./commands.sh
source <( printf 'UPD=( %s )' "$(sed <<<"${UPDATE}" -E -e 's/\t/=/g' -e 's/=(true|false)/="\1"/')" )
for ((num=0; num<=max; num++)); do
process_client "$num" "${debug}"
done
}
2019-04-21 11:45:51 +00:00
process_client() {
local num="$1" debug="$2"
2019-05-22 16:43:20 +00:00
iQUERY[ID]="${UPD["result",${num},"inline_query","id"]}"
2019-05-02 10:33:10 +00:00
if [ "${iQUERY[ID]}" = "" ]; then
2019-05-19 11:59:36 +00:00
[[ "${debug}" = *"debug"* ]] && cat <<< "$UPDATE" >>"MESSAGE.log"
process_message "${num}" "${debug}"
2019-05-02 10:33:10 +00:00
else
2019-05-19 11:59:36 +00:00
[[ "${debug}" = *"debug"* ]] && cat <<< "$UPDATE" >>"INLINE.log"
[ "$INLINE" != "0" ] && _is_function process_inline && process_inline "${num}" "${debug}"
2019-05-02 10:33:10 +00:00
fi
# shellcheck source=./commands.sh
source "${COMMANDS}" "${debug}"
2019-04-21 11:45:51 +00:00
tmpcount="COUNT${CHAT[ID]}"
grep -q "$tmpcount" <"${COUNTFILE}" &>/dev/null || cat <<< "$tmpcount" >>"${COUNTFILE}"
2019-04-21 11:45:51 +00:00
# To get user count execute bash bashbot.sh count
}
process_inline() {
local num="${1}"
2019-05-22 16:43:20 +00:00
iQUERY[0]="$(JsonDecode "${UPD["result",${num},"inline_query","query"]}")"
iQUERY[USER_ID]="${UPD["result",${num},"inline_query","from","id"]}"
iQUERY[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"inline_query","from","first_name"]}")"
iQUERY[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"inline_query","from","last_name"]}")"
iQUERY[USERNAME]="$(JsonDecode "${UPD["result",${num},"inline_query","from","username"]}")"
}
2019-04-21 11:45:51 +00:00
process_message() {
local num="$1"
# Message
2019-05-22 16:43:20 +00:00
MESSAGE[0]="$(JsonDecode "${UPD["result",${num},"message","text"]}" | sed 's#\\/#/#g')"
MESSAGE[ID]="${UPD["result",${num},"message","message_id"]}"
# Chat
2019-05-22 16:43:20 +00:00
CHAT[ID]="${UPD["result",${num},"message","chat","id"]}"
CHAT[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"message","chat","last_name"]}")"
CHAT[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"message","chat","first_name"]}")"
CHAT[USERNAME]="$(JsonDecode "${UPD["result",${num},"message","chat","username"]}")"
CHAT[TITLE]="$(JsonDecode "${UPD["result",${num},"message","chat","title"]}")"
CHAT[TYPE]="$(JsonDecode "${UPD["result",${num},"message","chat","type"]}")"
CHAT[ALL_ADMIN]="${UPD["result",${num},"message","chat","all_members_are_administrators"]}"
CHAT[ALL_MEMBERS_ARE_ADMINISTRATORS]="${CHAT[ALL_ADMIN]}" # backward compatibility
2016-01-17 16:46:24 +00:00
# User
2019-05-22 16:43:20 +00:00
USER[ID]="${UPD["result",${num},"message","from","id"]}"
USER[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"message","from","first_name"]}")"
USER[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"message","from","last_name"]}")"
USER[USERNAME]="$(JsonDecode "${UPD["result",${num},"message","from","username"]}")"
2016-01-17 16:46:24 +00:00
# in reply to message from
2019-05-22 16:43:20 +00:00
REPLYTO[UID]="${UPD["result",${num},"message","reply_to_message","from","id"]}"
if [ "${REPLYTO[UID]}" != "" ]; then
2019-05-22 16:43:20 +00:00
REPLYTO[0]="$(JsonDecode "${UPD["result",${num},"message","reply_to_message","text"]}")"
REPLYTO[ID]="${UPD["result",${num},"message","reply_to_message","message_id"]}"
REPLYTO[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"message","reply_to_message","from","first_name"]}")"
REPLYTO[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"message","reply_to_message","from","last_name"]}")"
REPLYTO[USERNAME]="$(JsonDecode "${UPD["result",${num},"message","reply_to_message","from","username"]}")"
fi
# forwarded message from
2019-05-22 16:43:20 +00:00
FORWARD[UID]="${UPD["result",${num},"message","forward_from","id"]}"
if [ "${FORWARD[UID]}" != "" ]; then
FORWARD[ID]="${MESSAGE[ID]}" # same as message ID
2019-05-22 16:43:20 +00:00
FORWARD[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"message","forward_from","first_name"]}")"
FORWARD[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"message","forward_from","last_name"]}")"
FORWARD[USERNAME]="$(JsonDecode "${UPD["result",${num},"message","forward_from","username"]}")"
fi
2016-01-17 16:46:24 +00:00
# Audio
2019-05-22 16:43:20 +00:00
URLS[AUDIO]="$(get_file "${UPD["result",${num},"message","audio","file_id"]}")"
2016-01-19 19:27:09 +00:00
# Document
2019-05-22 16:43:20 +00:00
URLS[DOCUMENT]="$(get_file "${UPD["result",${num},"message","document","file_id"]}")"
2016-01-17 16:46:24 +00:00
# Photo
2019-05-22 16:43:20 +00:00
URLS[PHOTO]="$(get_file "${UPD["result",${num},"message","photo",0,"file_id"]}")"
2016-01-17 16:46:24 +00:00
# Sticker
2019-05-22 16:43:20 +00:00
URLS[STICKER]="$(get_file "${UPD["result",${num},"message","sticker","file_id"]}")"
2016-01-17 16:46:24 +00:00
# Video
2019-05-22 16:43:20 +00:00
URLS[VIDEO]="$(get_file "${UPD["result",${num},"message","video","file_id"]}")"
2016-01-17 16:46:24 +00:00
# Voice
2019-05-22 16:43:20 +00:00
URLS[VOICE]="$(get_file "${UPD["result",${num},"message","voice","file_id"]}")"
2016-01-17 16:46:24 +00:00
# Contact
2019-05-22 16:43:20 +00:00
CONTACT[FIRST_NAME]="$(JsonDecode "${UPD["result",${num},"message","contact","first_name"]}")"
2019-05-22 08:01:39 +00:00
if [ "${CONTACT[FIRST_NAME]}" != "" ]; then
2019-05-22 16:43:20 +00:00
CONTACT[USER_ID]="$(JsonDecode "${UPD["result",${num},"message","contact","user_id"]}")"
CONTACT[LAST_NAME]="$(JsonDecode "${UPD["result",${num},"message","contact","last_name"]}")"
CONTACT[NUMBER]="${UPD["result",${num},"message","contact","phone_number"]}"
CONTACT[VCARD]="$(JsonGetString '"result",'"${num}"',"message","contact","vcard"' <<<"${UPDATE}")"
2019-05-22 08:01:39 +00:00
fi
2019-04-23 17:00:17 +00:00
# vunue
2019-05-22 16:43:20 +00:00
VENUE[TITLE]="$(JsonDecode "${UPD["result",${num},"message","venue","title"]}")"
2019-05-22 08:01:39 +00:00
if [ "${VENUE[TITLE]}" != "" ]; then
2019-05-22 16:43:20 +00:00
VENUE[ADDRESS]="$(JsonDecode "${UPD["result",${num},"message","venue","address"]}")"
VENUE[LONGITUDE]="${UPD["result",${num},"message","venue","location","longitude"]}"
VENUE[LATITUDE]="${UPD["result",${num},"message","venue","location","latitude"]}"
VENUE[FOURSQUARE]="${UPD["result",${num},"message","venue","foursquare_id"]}"
2019-05-22 08:01:39 +00:00
fi
2016-01-17 16:46:24 +00:00
# Caption
2019-05-22 16:43:20 +00:00
CAPTION="$(JsonDecode "${UPD["result",${num},"message","caption"]}")"
2016-01-17 16:46:24 +00:00
# Location
2019-05-22 16:43:20 +00:00
LOCATION[LONGITUDE]="${UPD["result",${num},"message","location","longitude"]}"
LOCATION[LATITUDE]="${UPD["result",${num},"message","location","latitude"]}"
}
2019-04-22 19:05:52 +00:00
#########################
2019-04-22 19:05:52 +00:00
# main get updates loop, should never terminate
start_bot() {
2019-05-10 09:33:41 +00:00
local DEBUG="$1"
2019-04-23 16:11:24 +00:00
local OFFSET=0
2019-04-22 19:50:38 +00:00
local mysleep="100" # ms
2019-04-23 10:48:05 +00:00
local addsleep="100"
local maxsleep="$(( ${BASHBOT_SLEEP:-5000} + 100 ))"
2019-05-10 09:33:41 +00:00
[[ "${DEBUG}" = *"debug" ]] && exec &>>"DEBUG.log"
2019-05-10 16:50:30 +00:00
[ "${DEBUG}" != "" ] && date && echo "Start BASHBOT in Mode \"${DEBUG}\""
2019-05-10 09:33:41 +00:00
[[ "${DEBUG}" = "xdebug"* ]] && set -x
#cleaup old pipes and empty logfiles
2019-05-19 10:54:59 +00:00
find "${TMPDIR}" -type p -delete
find "${TMPDIR}" -size 0 -name "*.log" -delete
2019-05-19 10:54:59 +00:00
while true; do
UPDATE="$(getJson "$UPD_URL$OFFSET" | "${JSONSHFILE}" -s -b -n)"
2019-04-22 19:05:52 +00:00
# Offset
2019-05-10 09:33:41 +00:00
OFFSET="$(grep <<< "${UPDATE}" '\["result",[0-9]*,"update_id"\]' | tail -1 | cut -f 2)"
((OFFSET++))
2019-04-22 19:05:52 +00:00
if [ "$OFFSET" != "1" ]; then
2019-04-22 19:50:38 +00:00
mysleep="100"
2019-05-10 09:33:41 +00:00
process_updates "${DEBUG}" &
2019-04-22 19:05:52 +00:00
fi
2019-04-22 19:50:38 +00:00
# adaptive sleep in ms rounded to next lower second
2019-05-10 09:33:41 +00:00
[ "${mysleep}" -gt "999" ] && sleep "${mysleep%???}"
# bash aritmetic
((mysleep+= addsleep , mysleep= mysleep>maxsleep ?maxsleep:mysleep))
2019-04-22 19:05:52 +00:00
done
}
# initialize bot environment, user and permissions
bot_init() {
# upgrade from old version
2019-04-23 16:11:24 +00:00
local OLDTMP="${BASHBOT_VAR:-.}/tmp-bot-bash"
[ -d "${OLDTMP}" ] && { mv -n "${OLDTMP}/"* "${TMPDIR}"; rmdir "${OLDTMP}"; }
[ -f "modules/inline.sh" ] && rm -f "modules/inline.sh"
#setup bashbot
[[ "${UID}" -eq "0" ]] && RUNUSER="nobody"
2019-04-22 19:05:52 +00:00
echo -n "Enter User to run basbot [$RUNUSER]: "
read -r TOUSER
[ "$TOUSER" = "" ] && TOUSER="$RUNUSER"
if ! id "$TOUSER" &>/dev/null; then
2019-04-22 19:05:52 +00:00
echo -e "${RED}User \"$TOUSER\" not found!${NC}"
exit 3
else
# shellcheck disable=SC2009
oldbot="$(ps -fu "$TOUSER" | grep startbot | grep -v -e 'grep' -e '\-startbot' )"
[ "${oldbot}" != "" ] && \
echo -e "${ORANGE}Warning: At least one not upgraded TMUX bot is running! You must stop it with kill command:${NC}\\n${oldbot}"
2019-04-22 19:05:52 +00:00
echo "Adjusting user \"${TOUSER}\" files and permissions ..."
[ -w "bashbot.rc" ] && sed -i '/^[# ]*runas=/ s/runas=.*$/runas="'$TOUSER'"/' "bashbot.rc"
2019-04-22 19:05:52 +00:00
chown -R "$TOUSER" . ./*
chmod 711 .
chmod -R a-w ./*
chmod -R u+w "${COUNTFILE}" "${TMPDIR}" "${BOTADMIN}" ./*.log 2>/dev/null
chmod -R o-r,o-w "${COUNTFILE}" "${TMPDIR}" "${TOKENFILE}" "${BOTADMIN}" "${BOTACL}" 2>/dev/null
ls -la
fi
}
JSONSHFILE="${BASHBOT_JSONSH:-${RUNDIR}/JSON.sh/JSON.sh}"
[[ "${JSONSHFILE}" != *"/JSON.sh" ]] && echo -e "${RED}ERROR: \"${JSONSHFILE}\" ends not with \"JSONS.sh\".${NC}" && exit 3
if [ ! -f "${JSONSHFILE}" ]; then
echo "Seems to be first run, Downloading ${JSONSHFILE}..."
2019-05-16 14:42:38 +00:00
[[ "${JSONSHFILE}" = "${RUNDIR}/JSON.sh/JSON.sh" ]] && mkdir "JSON.sh" 2>/dev/null && chmod +w "JSON.sh"
getJson "https://cdn.jsdelivr.net/gh/dominictarr/JSON.sh/JSON.sh" >"${JSONSHFILE}"
chmod +x "${JSONSHFILE}"
fi
ME="$(getBotName)"
if [ "$ME" = "" ] && [ "$1" != "source" ]; then
echo -e "${RED}ERROR: Can't connect to Telegram Bot! May be your TOKEN is invalid ...${NC}"
exit 1
fi
2016-03-20 21:34:55 +00:00
# source the script with source as param to use functions in other scripts
2019-04-20 14:26:16 +00:00
# do not execute if read from other scripts
if [ "$1" != "source" ]; then
2019-04-22 19:05:52 +00:00
##############
# internal options only for use from bashbot and developers
2019-04-20 14:26:16 +00:00
case "$1" in
2019-04-22 19:05:52 +00:00
"outproc") # forward output from interactive and jobs to chat
[ "$3" = "" ] && echo "No file to read from" && exit 3
[ "$2" = "" ] && echo "No chat to send to" && exit 3
2019-05-19 15:31:55 +00:00
while read -r line ;do
2019-05-18 18:25:18 +00:00
[ "$line" != "" ] && send_message "$2" "$line"
done
rm -f -r "${TMPDIR:-.}/$3"
2019-05-18 19:06:29 +00:00
[ -s "${TMPDIR:-.}/$3.log" ] || rm -f "${TMPDIR:-.}/$3.log"
2019-04-22 19:05:52 +00:00
exit
;;
"startbot" )
2019-04-22 19:50:38 +00:00
start_bot "$2"
2019-04-22 19:05:52 +00:00
exit
;;
2019-04-22 19:05:52 +00:00
"source") # this should never arrive here
exit
;;
"init") # adjust users and permissions
bot_init
exit
;;
esac
###############
# "official" arguments as shown to users
SESSION="$ME-startbot"
BOTPID="$(proclist "${SESSION}")"
2019-04-22 19:05:52 +00:00
case "$1" in
"count")
2019-04-20 14:26:16 +00:00
echo "A total of $(wc -l <"${COUNTFILE}") users used me."
exit
;;
"broadcast")
2019-04-20 14:26:16 +00:00
NUMCOUNT="$(wc -l <"${COUNTFILE}")"
2019-04-08 10:40:07 +00:00
echo "Sending the broadcast $* to $NUMCOUNT users."
[ "$NUMCOUNT" -gt "300" ] && sleep="sleep 0.5"
shift
while read -r f; do send_markdown_message "${f//COUNT}" "$*"; $sleep; done <"${COUNTFILE}"
;;
"status")
if [ "${BOTPID}" != "" ]; then
echo -e "${GREEN}Bot is running.${NC}"
exit
else
echo -e "${ORANGE}Bot not running.${NC}"
exit 5
fi
;;
2016-04-17 12:13:28 +00:00
"start")
# shellcheck disable=SC2086
[ "${BOTPID}" != "" ] && kill ${BOTPID}
nohup "$SCRIPT" "startbot" "$2" "${SESSION}" &>/dev/null &
echo "Session Name: ${SESSION}"
if [ "$(proclist "${SESSION}")" != "" ]; then
echo -e "${GREEN}Bot started successfully.${NC}"
else
echo -e "${RED}An error occurred while starting the bot.${NC}"
exit 5
fi
2016-04-17 12:13:28 +00:00
;;
"kill"|"stop")
if [ "${BOTPID}" != "" ]; then
# shellcheck disable=SC2086
if kill ${BOTPID}; then
echo -e "${GREEN}OK. Bot stopped successfully.${NC}"
else
echo -e "${RED}An error occured while stopping bot.${NC}"
exit 5
fi
fi
exit
2019-03-25 10:15:07 +00:00
;;
"resumeb"* | "killb"* | "suspendb"*)
_is_function job_control || { echo -e "${RED}Module background is not availible!${NC}"; exit 3; }
job_control "$1"
;;
2016-04-17 12:13:28 +00:00
"help")
2019-04-09 11:41:38 +00:00
less "README.txt"
2019-04-01 10:52:25 +00:00
exit
;;
*)
echo -e "${RED}${ME}: BAD REQUEST${NC}"
echo -e "${RED}Available arguments: start, stop, kill, status, count, broadcast, help, suspendback, resumeback, killback${NC}"
2016-04-17 12:13:28 +00:00
;;
2019-04-20 14:26:16 +00:00
esac
2019-04-20 14:26:16 +00:00
# warn if root
if [[ "${UID}" -eq "0" ]] ; then
echo -e "\\n${ORANGE}WARNING: ${SCRIPT} was started as ROOT (UID 0)!${NC}"
echo -e "${ORANGE}You are at HIGH RISK when running a Telegram BOT with root privilegs!${NC}"
2019-04-20 14:26:16 +00:00
fi
fi # end source